## rvencio jan 2010 @seattle rvencio@gmail.com ##

## load original normalized file.
x = read.delim("data.txt") # do not forget to unzip data.zip first

## create a file with just the means.
y = x[,1:4] # IDs, gene names and etc.
j = c(99,96,98,95,97) # Luminal
y = data.frame(y, L = signif(apply(x[,j], 1, mean),3) )
j = c(40,36,41,37,39) # Basal
y = data.frame(y, B = signif(apply(x[,j], 1, mean),3) )
j = c(82,81,79,78,80) # Endothelial
y = data.frame(y, E = signif(apply(x[,j], 1, mean),3) )
j = c(129,131,130,127,128) # Stromal
y = data.frame(y, S = signif(apply(x[,j], 1, mean),3) )


## create the rotation matrix W.
w = y[,-1:-4] # just numeric data. get rid of IDs, gene names and etc.
PCA = prcomp(t(w))
W = PCA$rotation[,1:3] # rotation matrix

## rotate and project data (the same that created PC space).
w = y[,-1:-4]
Z = t(as.matrix(t(W)) %*% as.matrix(w)) # new coordinates of w at the rotated axis.
z = Z[,1:3] # projection. We want here just 3 dimensions.

## rotate and project data (all points, nobrainer)
w = x[,-1:-4]
Z = t(as.matrix(t(W)) %*% as.matrix(w)) # new coordinates of w at the rotated axis.
z = rbind(z, Z[,1:3]) # projection. 

write.table(z, "PCA_table.txt", sep="\t", quote=F)

